// Code generated by ent, DO NOT EDIT.

package chat

import (
	"gochassis/ent/predicate"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldID, id))
}

// Text applies equality check predicate on the "text" field. It's identical to TextEQ.
func Text(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldText, v))
}

// Attachment applies equality check predicate on the "attachment" field. It's identical to AttachmentEQ.
func Attachment(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldAttachment, v))
}

// AttachmentType applies equality check predicate on the "attachment_type" field. It's identical to AttachmentTypeEQ.
func AttachmentType(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldAttachmentType, v))
}

// FrontendUUID applies equality check predicate on the "frontend_uuid" field. It's identical to FrontendUUIDEQ.
func FrontendUUID(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldFrontendUUID, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldUpdatedAt, v))
}

// DeletedAt applies equality check predicate on the "deleted_at" field. It's identical to DeletedAtEQ.
func DeletedAt(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldDeletedAt, v))
}

// ReplyTo applies equality check predicate on the "reply_to" field. It's identical to ReplyToEQ.
func ReplyTo(v int) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldReplyTo, v))
}

// TextEQ applies the EQ predicate on the "text" field.
func TextEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldText, v))
}

// TextNEQ applies the NEQ predicate on the "text" field.
func TextNEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldText, v))
}

// TextIn applies the In predicate on the "text" field.
func TextIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldText, vs...))
}

// TextNotIn applies the NotIn predicate on the "text" field.
func TextNotIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldText, vs...))
}

// TextGT applies the GT predicate on the "text" field.
func TextGT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldText, v))
}

// TextGTE applies the GTE predicate on the "text" field.
func TextGTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldText, v))
}

// TextLT applies the LT predicate on the "text" field.
func TextLT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldText, v))
}

// TextLTE applies the LTE predicate on the "text" field.
func TextLTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldText, v))
}

// TextContains applies the Contains predicate on the "text" field.
func TextContains(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContains(FieldText, v))
}

// TextHasPrefix applies the HasPrefix predicate on the "text" field.
func TextHasPrefix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasPrefix(FieldText, v))
}

// TextHasSuffix applies the HasSuffix predicate on the "text" field.
func TextHasSuffix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasSuffix(FieldText, v))
}

// TextEqualFold applies the EqualFold predicate on the "text" field.
func TextEqualFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEqualFold(FieldText, v))
}

// TextContainsFold applies the ContainsFold predicate on the "text" field.
func TextContainsFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContainsFold(FieldText, v))
}

// AttachmentEQ applies the EQ predicate on the "attachment" field.
func AttachmentEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldAttachment, v))
}

// AttachmentNEQ applies the NEQ predicate on the "attachment" field.
func AttachmentNEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldAttachment, v))
}

// AttachmentIn applies the In predicate on the "attachment" field.
func AttachmentIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldAttachment, vs...))
}

// AttachmentNotIn applies the NotIn predicate on the "attachment" field.
func AttachmentNotIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldAttachment, vs...))
}

// AttachmentGT applies the GT predicate on the "attachment" field.
func AttachmentGT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldAttachment, v))
}

// AttachmentGTE applies the GTE predicate on the "attachment" field.
func AttachmentGTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldAttachment, v))
}

// AttachmentLT applies the LT predicate on the "attachment" field.
func AttachmentLT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldAttachment, v))
}

// AttachmentLTE applies the LTE predicate on the "attachment" field.
func AttachmentLTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldAttachment, v))
}

// AttachmentContains applies the Contains predicate on the "attachment" field.
func AttachmentContains(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContains(FieldAttachment, v))
}

// AttachmentHasPrefix applies the HasPrefix predicate on the "attachment" field.
func AttachmentHasPrefix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasPrefix(FieldAttachment, v))
}

// AttachmentHasSuffix applies the HasSuffix predicate on the "attachment" field.
func AttachmentHasSuffix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasSuffix(FieldAttachment, v))
}

// AttachmentIsNil applies the IsNil predicate on the "attachment" field.
func AttachmentIsNil() predicate.Chat {
	return predicate.Chat(sql.FieldIsNull(FieldAttachment))
}

// AttachmentNotNil applies the NotNil predicate on the "attachment" field.
func AttachmentNotNil() predicate.Chat {
	return predicate.Chat(sql.FieldNotNull(FieldAttachment))
}

// AttachmentEqualFold applies the EqualFold predicate on the "attachment" field.
func AttachmentEqualFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEqualFold(FieldAttachment, v))
}

// AttachmentContainsFold applies the ContainsFold predicate on the "attachment" field.
func AttachmentContainsFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContainsFold(FieldAttachment, v))
}

// AttachmentTypeEQ applies the EQ predicate on the "attachment_type" field.
func AttachmentTypeEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldAttachmentType, v))
}

// AttachmentTypeNEQ applies the NEQ predicate on the "attachment_type" field.
func AttachmentTypeNEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldAttachmentType, v))
}

// AttachmentTypeIn applies the In predicate on the "attachment_type" field.
func AttachmentTypeIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldAttachmentType, vs...))
}

// AttachmentTypeNotIn applies the NotIn predicate on the "attachment_type" field.
func AttachmentTypeNotIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldAttachmentType, vs...))
}

// AttachmentTypeGT applies the GT predicate on the "attachment_type" field.
func AttachmentTypeGT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldAttachmentType, v))
}

// AttachmentTypeGTE applies the GTE predicate on the "attachment_type" field.
func AttachmentTypeGTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldAttachmentType, v))
}

// AttachmentTypeLT applies the LT predicate on the "attachment_type" field.
func AttachmentTypeLT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldAttachmentType, v))
}

// AttachmentTypeLTE applies the LTE predicate on the "attachment_type" field.
func AttachmentTypeLTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldAttachmentType, v))
}

// AttachmentTypeContains applies the Contains predicate on the "attachment_type" field.
func AttachmentTypeContains(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContains(FieldAttachmentType, v))
}

// AttachmentTypeHasPrefix applies the HasPrefix predicate on the "attachment_type" field.
func AttachmentTypeHasPrefix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasPrefix(FieldAttachmentType, v))
}

// AttachmentTypeHasSuffix applies the HasSuffix predicate on the "attachment_type" field.
func AttachmentTypeHasSuffix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasSuffix(FieldAttachmentType, v))
}

// AttachmentTypeIsNil applies the IsNil predicate on the "attachment_type" field.
func AttachmentTypeIsNil() predicate.Chat {
	return predicate.Chat(sql.FieldIsNull(FieldAttachmentType))
}

// AttachmentTypeNotNil applies the NotNil predicate on the "attachment_type" field.
func AttachmentTypeNotNil() predicate.Chat {
	return predicate.Chat(sql.FieldNotNull(FieldAttachmentType))
}

// AttachmentTypeEqualFold applies the EqualFold predicate on the "attachment_type" field.
func AttachmentTypeEqualFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEqualFold(FieldAttachmentType, v))
}

// AttachmentTypeContainsFold applies the ContainsFold predicate on the "attachment_type" field.
func AttachmentTypeContainsFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContainsFold(FieldAttachmentType, v))
}

// FrontendUUIDEQ applies the EQ predicate on the "frontend_uuid" field.
func FrontendUUIDEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldFrontendUUID, v))
}

// FrontendUUIDNEQ applies the NEQ predicate on the "frontend_uuid" field.
func FrontendUUIDNEQ(v string) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldFrontendUUID, v))
}

// FrontendUUIDIn applies the In predicate on the "frontend_uuid" field.
func FrontendUUIDIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldFrontendUUID, vs...))
}

// FrontendUUIDNotIn applies the NotIn predicate on the "frontend_uuid" field.
func FrontendUUIDNotIn(vs ...string) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldFrontendUUID, vs...))
}

// FrontendUUIDGT applies the GT predicate on the "frontend_uuid" field.
func FrontendUUIDGT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldFrontendUUID, v))
}

// FrontendUUIDGTE applies the GTE predicate on the "frontend_uuid" field.
func FrontendUUIDGTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldFrontendUUID, v))
}

// FrontendUUIDLT applies the LT predicate on the "frontend_uuid" field.
func FrontendUUIDLT(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldFrontendUUID, v))
}

// FrontendUUIDLTE applies the LTE predicate on the "frontend_uuid" field.
func FrontendUUIDLTE(v string) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldFrontendUUID, v))
}

// FrontendUUIDContains applies the Contains predicate on the "frontend_uuid" field.
func FrontendUUIDContains(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContains(FieldFrontendUUID, v))
}

// FrontendUUIDHasPrefix applies the HasPrefix predicate on the "frontend_uuid" field.
func FrontendUUIDHasPrefix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasPrefix(FieldFrontendUUID, v))
}

// FrontendUUIDHasSuffix applies the HasSuffix predicate on the "frontend_uuid" field.
func FrontendUUIDHasSuffix(v string) predicate.Chat {
	return predicate.Chat(sql.FieldHasSuffix(FieldFrontendUUID, v))
}

// FrontendUUIDEqualFold applies the EqualFold predicate on the "frontend_uuid" field.
func FrontendUUIDEqualFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldEqualFold(FieldFrontendUUID, v))
}

// FrontendUUIDContainsFold applies the ContainsFold predicate on the "frontend_uuid" field.
func FrontendUUIDContainsFold(v string) predicate.Chat {
	return predicate.Chat(sql.FieldContainsFold(FieldFrontendUUID, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldUpdatedAt, v))
}

// DeletedAtEQ applies the EQ predicate on the "deleted_at" field.
func DeletedAtEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldDeletedAt, v))
}

// DeletedAtNEQ applies the NEQ predicate on the "deleted_at" field.
func DeletedAtNEQ(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldDeletedAt, v))
}

// DeletedAtIn applies the In predicate on the "deleted_at" field.
func DeletedAtIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldDeletedAt, vs...))
}

// DeletedAtNotIn applies the NotIn predicate on the "deleted_at" field.
func DeletedAtNotIn(vs ...time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldDeletedAt, vs...))
}

// DeletedAtGT applies the GT predicate on the "deleted_at" field.
func DeletedAtGT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGT(FieldDeletedAt, v))
}

// DeletedAtGTE applies the GTE predicate on the "deleted_at" field.
func DeletedAtGTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldGTE(FieldDeletedAt, v))
}

// DeletedAtLT applies the LT predicate on the "deleted_at" field.
func DeletedAtLT(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLT(FieldDeletedAt, v))
}

// DeletedAtLTE applies the LTE predicate on the "deleted_at" field.
func DeletedAtLTE(v time.Time) predicate.Chat {
	return predicate.Chat(sql.FieldLTE(FieldDeletedAt, v))
}

// DeletedAtIsNil applies the IsNil predicate on the "deleted_at" field.
func DeletedAtIsNil() predicate.Chat {
	return predicate.Chat(sql.FieldIsNull(FieldDeletedAt))
}

// DeletedAtNotNil applies the NotNil predicate on the "deleted_at" field.
func DeletedAtNotNil() predicate.Chat {
	return predicate.Chat(sql.FieldNotNull(FieldDeletedAt))
}

// ReplyToEQ applies the EQ predicate on the "reply_to" field.
func ReplyToEQ(v int) predicate.Chat {
	return predicate.Chat(sql.FieldEQ(FieldReplyTo, v))
}

// ReplyToNEQ applies the NEQ predicate on the "reply_to" field.
func ReplyToNEQ(v int) predicate.Chat {
	return predicate.Chat(sql.FieldNEQ(FieldReplyTo, v))
}

// ReplyToIn applies the In predicate on the "reply_to" field.
func ReplyToIn(vs ...int) predicate.Chat {
	return predicate.Chat(sql.FieldIn(FieldReplyTo, vs...))
}

// ReplyToNotIn applies the NotIn predicate on the "reply_to" field.
func ReplyToNotIn(vs ...int) predicate.Chat {
	return predicate.Chat(sql.FieldNotIn(FieldReplyTo, vs...))
}

// ReplyToIsNil applies the IsNil predicate on the "reply_to" field.
func ReplyToIsNil() predicate.Chat {
	return predicate.Chat(sql.FieldIsNull(FieldReplyTo))
}

// ReplyToNotNil applies the NotNil predicate on the "reply_to" field.
func ReplyToNotNil() predicate.Chat {
	return predicate.Chat(sql.FieldNotNull(FieldReplyTo))
}

// HasProfile applies the HasEdge predicate on the "profile" edge.
func HasProfile() predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, ProfileTable, ProfileColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasProfileWith applies the HasEdge predicate on the "profile" edge with a given conditions (other predicates).
func HasProfileWith(preds ...predicate.Profile) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := newProfileStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasChatRoom applies the HasEdge predicate on the "chat_room" edge.
func HasChatRoom() predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, ChatRoomTable, ChatRoomColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasChatRoomWith applies the HasEdge predicate on the "chat_room" edge with a given conditions (other predicates).
func HasChatRoomWith(preds ...predicate.ChatRoom) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := newChatRoomStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReplyToEdge applies the HasEdge predicate on the "reply_to_edge" edge.
func HasReplyToEdge() predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, ReplyToEdgeTable, ReplyToEdgeColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasReplyToEdgeWith applies the HasEdge predicate on the "reply_to_edge" edge with a given conditions (other predicates).
func HasReplyToEdgeWith(preds ...predicate.Chat) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := newReplyToEdgeStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReplies applies the HasEdge predicate on the "replies" edge.
func HasReplies() predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, RepliesTable, RepliesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasRepliesWith applies the HasEdge predicate on the "replies" edge with a given conditions (other predicates).
func HasRepliesWith(preds ...predicate.Chat) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		step := newRepliesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Chat) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Chat) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Chat) predicate.Chat {
	return predicate.Chat(func(s *sql.Selector) {
		p(s.Not())
	})
}
